#include <TTCN3.hh>

#include "loggers.hh"
#include "registration.hh"

#include "AdapterControlPort_Pki.hh"
//=============================================================================
namespace LibItsPki__TestSystem {

  AdapterControlPort::AdapterControlPort(const char *par_port_name) : AdapterControlPort_BASE(par_port_name), _params() {
    loggers::get_instance().log("AdapterControlPort::AdapterControlPort");
  }

  AdapterControlPort::~AdapterControlPort() {}

  void AdapterControlPort::set_parameter(const char *parameter_name, const char *parameter_value) {
    loggers::get_instance().log("AdapterControlPort::set_parameter: %s=%s", parameter_name, parameter_value);
  }

  /*void AdapterControlPort::Handle_Fd_Event(int fd, boolean is_readable,
    boolean is_writable, boolean is_error) {}*/

  void AdapterControlPort::Handle_Fd_Event_Error(int /*fd*/) {}

  void AdapterControlPort::Handle_Fd_Event_Writable(int /*fd*/) {}

  void AdapterControlPort::Handle_Fd_Event_Readable(int /*fd*/) {}

  /*void AdapterControlPort::Handle_Timeout(double time_since_last_call) {}*/

  void AdapterControlPort::user_map(const char *system_port) { loggers::get_instance().log(">>> AdapterControlPort::user_map: %s", system_port); }

  void AdapterControlPort::user_unmap(const char *system_port) { loggers::get_instance().log(">>> AdapterControlPort::user_unmap: %s", system_port); }

  void AdapterControlPort::user_start() {}

  void AdapterControlPort::user_stop() {}

  void AdapterControlPort::outgoing_send(const LibItsPki__TypesAndValues::AcPkiPrimitive &send_par) {
    loggers::get_instance().log_msg(">>> AdapterControlPort::outgoing_send: ", send_par);

    // Register this object for AdapterControlPort
    pki_layer *p = registration<pki_layer>::get_instance().get_item(std::string("PKI"));
    if (p != NULL) {
      loggers::get_instance().log("AdapterControlPort::outgoing_send: Got PKI layer %p", p);
      LibItsPki__TypesAndValues::AcPkiResponse response;
      response.result() = BOOLEAN(false);
      if (send_par.ischosen(LibItsPki__TypesAndValues::AcPkiPrimitive::ALT_acSetSecurityData)) {
        loggers::get_instance().log("AdapterControlPort::outgoing_send: AcSetSecurityData");
        p->set_pki_keys(send_par.acSetSecurityData());
        response.result() = BOOLEAN(true);
      }
      // Send response
      loggers::get_instance().log_msg("AdapterControlPort::outgoing_send: Send response: ", response);
      incoming_message(response);
    } else {
      loggers::get_instance().error("AdapterControlPort::outgoing_send: pkiPort not registered");
    }
  }

} // namespace LibItsPki__TestSystem
