#!/bin/bash

#set -e
set -vx

echo -e "*****************************\n* Checkout TTF011 sources\n*****************************\n"
cd ${HOME}/dev || exit 1

git clone --recurse-submodules --single-branch https://forge.etsi.org/gitlab/ITS/ITS.git TTF011_Its
cd ./TTF011_Its
for i in `find ./ttcn -type d -name "Ats*"`
do
    cd $i
    git checkout devel
    cd -
done
for i in `find ./ttcn -type d -name "asn1"`
do
    cd $i
    git checkout testing
    cd -
done
cd /home/etsi/dev/TTF011_Its/ttcn/LibIts
git checkout TTF011
cd /home/etsi/dev/TTF011_Its/scripts
chmod 775 *.bash devenv.bash.*
cd /home/etsi
ln -sf /home/etsi/dev/TTF011_Its/scripts/devenv.bash.ubuntu /home/etsi/devenv.bash
ls -ltr /home/etsi

echo -e "*****************************\n* Init Workspace\n*****************************\n"
mkdir -p ${HOME}/dev/Workspace/TTF011/bin/asn1
cd ${HOME}/dev/Workspace/TTF011
ln -s ../../TTF011_Its/testdata
ln -s ../../TTF011_Its/data

echo -e "*****************************\n* Make Certificate generator \n*****************************\n"
# make V3 certificate generators
cd ${HOME}/dev/TTF011_Its/tools/itscertgen/asn1certgen
make

# generate certificates
cd ${HOME}/dev/TTF011_Its/data/v3
make

echo -e "*****************************\n* Install latest ETSI ITS plugtest certificates\n*****************************\n"
cp /home/etsi/dev/TTF011_Its/data/v3/asn1c_cert.tar.bz2 /home/etsi/tmp
cd /home/etsi/tmp
tar xvjf ./asn1c_cert.tar.bz2

cd ${HOME}

exit 0
